
    'wavshower
    
    '   Takes an eight bit mono wav file & displays whole trace.
    '   It then allows you to zoom in on any section.
    '   Could easily be modified to check & allow for other wav file structures.
    
    'To-dos-    play the section
    '           add options for ring modulation etc as in wavplot5
    '           add echo option
    '           add back the saving of the screen display
    '           remove marker bars before drawing limits of new selection
    

    '           See Thomas Watson's 'wave5' for further ideas on wav generation
    '               use it to generate a sample wave
    '           Or use Alyce's wavy sound wave recorder...
    
    
    '           Google for wav file structure- info easily avaiilable
    
    nomainwin

    WindowWidth     = 790
    WindowHeight    = 540
    UpperLeftX      =   1
    UpperLeftY      =   1

    f  = 2'     y scaling factor
    t1 =46

    graphicbox #h.g,   10,   4, 700, 370
    graphicbox #h.g2,  10, 420, 700,  90

    textbox    #h.t1, 720,  52,  30,  20
    textbox    #h.t4,  10, 375,  90,  20
    textbox    #h.t5, 623, 375,  90,  20
    textbox    #h.t6,  10, 395,  90,  20
    textbox    #h.t7, 623, 395,  90,  20
    textbox    #h.t8, 140, 375, 480,  20
    textbox    #h.t9, 140, 395, 480,  20

    button     #h.b1, "y Gain +",   [scaleup],      UR,  10,  20
    button     #h.b2, "y Gain -",   [scaledown],    UR,  10,  80

    button     #h.b3, "Draw",       [ShowData],     LL, 730,  90


    open "johnf- Xmas 2004- CRO display-    set up for 8bit mono wav files only at present" for window_nf as #h
    print #h,       "trapclose [quit]"
    #h.t8, "Whole trace is displayed & played. Use mouse left/right clicks on this to choose sample start/ end."
    #h.t9, "You may want to choose a different vertical ( y) gain."

    filedialog "Open file to view", "Houston8.wav", currentFile$
        ' I am only bothering with 8bit mono- could easily adapt to other wavs
    open currentFile$ for input as #f
    playwave currentFile$, async
    Le =lof( #f)
    t2 =Le
    #h.t6, "Start=46"
    #h.t7, "End ="; Le
    i$ =input$( #f, Le)'    i$ now holds a memory resident copy of the wav file

    #h.t1, f
    #h.g2, "when  leftButtonDown [limit1]"
    #h.g2, "when rightButtonDown [limit2]"
    #h.g2, "setfocus"

    #h.g2, "cls ; down ; fill darkgray ; color green ; line 700 100  0 100"

    for x = 46 to Le step int( (Le-46)/20000)
        'scan
        x$ =mid$( i$, x, 1)
        v  =asc( x$) -128'   0 (-127) to 255 (+127) with 128 as zero
        #h.g2, "set "; (x-45)/Le*700; " ";  45 +v/3
    next x
    #h.g2, "flush"
    wait

[ShowData]
    #h.g, "cls ; down ; fill darkgray ; color green ; line 700 198  0 198"
    if t2 <t1+1000 then
        t2 =min( t1+1000, Le)
        #h.t5, "t2 ="; t2
        #h.g2, "setfocus"
    end if
    #h.g2, "down ; color "; int(255*rnd(1)); " "; int(255*rnd(1)); " "; int(255*rnd(1))
    #h.g2, "line "; t1/Le*700; " 50 "; t1/Le*700; " 0"
    #h.g2, "line "; t2/Le*700; " 50 "; t2/Le*700; "  0"
    #h.g2, "color "; int(255*rnd(1)); " "; int(255*rnd(1)); " "; int(255*rnd(1)); " up "
    for x = t1 to t2 step int( (t2-t1)/700)
        scan
        x$ =mid$( i$, x, 1)
        v  =asc( x$) -128'   0 (-127) to 255 (+127) with 128 as zero
        #h.g, "goto "; (x-t1)/(t2-t1)*700; " "; 198 +f *v
    next x
    #h.g, "flush"
    #h.g2, "setfocus"
    wait

[limit1]
    t1 =46 +int( MouseX /700 *Le)
    #h.t4, "t1 ="; t1
    #h.g2, "setfocus"
    wait

[limit2]
    t2 =46 +int( MouseX /700 *Le)
    #h.t5, "t2 ="; t2
    #h.g2, "setfocus"
    wait

[scaleup]
    f =f*2^0.5
    #h.t1, f
        #h.g2, "setfocus"
    wait

[scaledown]
    f =f/2^0.5
    #h.t1, f
        #h.g2, "setfocus"
    wait

[quit]
    close #f
    close #h
    end


